
    <!DOCTYPE html>
    <html>
      <head>
        <meta charset="utf-8">
      </head>
      <body>
<div class="marpit"><svg data-marpit-svg="" viewBox="0 0 1280 5000"><foreignObject width="1280" height="5000"><section id="1" data-marpit-fragments="16">
<h1>CRUD in memory</h1>
<p>CRUD — широко распространенный термин, означающий 4 стандартные операции над любой сущностью: создание, чтение, обновление и удаление. Часть CRUD, чтение и удаление, мы сделали в прошлом домашнем задании. В этом домашнем задании вам нужно будет реализовать оставшуюся часть CRUD — создание и обновление сущности. Создание и обновление сущности включают в себя по два действия: отображение формы и обработка данных формы.</p>
<h2>Ссылки</h2>
<ul>
<li data-marpit-fragment="1"><a href="https://bootstrap-4.ru/docs/5.0/forms/overview/">Формы Bootstrap</a></li>
<li data-marpit-fragment="2"><a href="https://developer.mozilla.org/ru/docs/Web/HTML/Element/form">Html тег form</a></li>
<li data-marpit-fragment="3"><a href="https://javaee.github.io/javaee-spec/javadocs/javax/servlet/ServletRequest.html#getParameter-java.lang.String-">Метод getParameter()</a></li>
<li data-marpit-fragment="4"><a href="https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input">Тег input</a></li>
<li data-marpit-fragment="5"><a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/util/Map.html#getOrDefault(java.lang.Object,V)">Метод getOrDefault()</a></li>
</ul>
<h2>servlet/UsersServlet.java</h2>
<p>В этом упражнении мы продолжаем работать с данными, которые расположены в памяти. Список пользователей уже создан и записан в свойстве <code>users</code> класса <code>UsersServlet</code>. Структура списка такая же, как и в предыдущем упражнении.</p>
<h2>Задачи</h2>
<ul>
<li data-marpit-fragment="6">
<p>Изучите содержимое методов <code>doGet()</code> и <code>doPost()</code>, которые в зависимости от пути в адресе запроса вызывают нужный обработчик (метод).</p>
</li>
<li data-marpit-fragment="7">
<p>Метод <code>newUser()</code> выводит страницу с формой создания нового пользователя. Организуйте передачу управления в jsp-файл <em>/new.jsp</em>.</p>
</li>
<li data-marpit-fragment="8">
<p>Метод <code>editUser()</code> выводит страницу с формой редактирования пользователя. Организуйте передачу управления в jsp-файл <em>/edit.jsp</em>. Для удобства работы все поля формы должны быть заполнены данными пользователя. Для этого вам понадобится передать в jsp-файл данные пользователя.</p>
</li>
<li data-marpit-fragment="9">
<p>Метод <code>createUser()</code> обрабатывает данные формы создания нового пользователя. В методе реализуйте добавление нового пользователя в список пользователей. Чтобы получить из запроса данные, которые пользователь ввёл в форму, воспользуйтесь методом <code>getParameter()</code> класса <code>HttpServletRequest</code>. В этом методе вам нужно будет выполнить валидацию — проверку корректности введенных данных пользователя. Имя и фамилия пользователя не должны быть пустыми. Если введенные данные не корректны, установите код ответа 422 (Unprocessable Entity) и отобразите страницу создания пользователя, передав управление в файл <em>/new.jsp</em>. Для того, чтобы на странице создания пользователя отобразить ошибку и заполнить поля формы, вам потребуется передать в форму сообщение об ошибке и введенные данные пользователя. Если данные корректны, добавьте пользователя в список и выполните редирект на страницу просмотра всех пользователей. Для генерации нового id используйте метод <code>getNextId()</code>.</p>
</li>
<li data-marpit-fragment="10">
<p>Метод <code>updateUser()</code> обрабатывает данные формы редактирования пользователя. В методе реализуйте обновление данных пользователя. Проверьте корректность введенных данных пользователя. Имя и фамилия пользователя не должны быть пустыми. Если введенные данные не корректны, установите код ответа 422 (Unprocessable Entity) и отобразите страницу редактирования пользователя, передав управление в файл <em>/edit.jsp</em>. Для того, чтобы на странице редактирования пользователя отобразить ошибку и заполнить поля формы данными, вам потребуется передать в форму сообщение об ошибке и введенные данные пользователя. Если данные корректны, скопируйте введенные данные из формы в сущность и сделайте редирект на станицу пользователя.</p>
</li>
</ul>
<h2>webapp/new.jsp</h2>
<p>Шаблон с формой создания нового пользователя.</p>
<h2>Задачи</h2>
<ul>
<li data-marpit-fragment="11">Организуйте вывод формы создания нового пользователя. Для создания текстовых полей используйте тег <code>&lt;input&gt;</code>. В форме должно быть три текстовых поля для ввода имени, фамилии и email пользователя. Если были введены некорректные данные, на странице должно выводиться сообщение об ошибке, а поля должны быть заполнены введенными данными. Чтобы добавить немного красоты в форму, используйте классы bootstrap.</li>
</ul>
<pre><code class="language-html"><span class="hljs-tag">&lt;<span class="hljs-name">form</span> <span class="hljs-attr">action</span>=<span class="hljs-string">&quot;url&quot;</span> <span class="hljs-attr">method</span>=<span class="hljs-string">&quot;post&quot;</span>&gt;</span>
    <span class="hljs-tag">&lt;<span class="hljs-name">div</span> <span class="hljs-attr">class</span>=<span class="hljs-string">&quot;mb-3&quot;</span>&gt;</span>
        <span class="hljs-tag">&lt;<span class="hljs-name">label</span>&gt;</span>Имя<span class="hljs-tag">&lt;/<span class="hljs-name">label</span>&gt;</span>
        <span class="hljs-tag">&lt;<span class="hljs-name">input</span> <span class="hljs-attr">class</span>=<span class="hljs-string">&quot;form-control&quot;</span> <span class="hljs-attr">type</span>=<span class="hljs-string">&quot;text&quot;</span> <span class="hljs-attr">name</span>=<span class="hljs-string">&quot;firstName&quot;</span> <span class="hljs-attr">value</span>=<span class="hljs-string">&quot;&quot;</span>&gt;</span>
    <span class="hljs-tag">&lt;/<span class="hljs-name">div</span>&gt;</span>
    <span class="hljs-tag">&lt;<span class="hljs-name">button</span> <span class="hljs-attr">class</span>=<span class="hljs-string">&quot;btn btn-primary&quot;</span> <span class="hljs-attr">type</span>=<span class="hljs-string">&quot;submit&quot;</span>&gt;</span>Создать<span class="hljs-tag">&lt;/<span class="hljs-name">button</span>&gt;</span>
<span class="hljs-tag">&lt;/<span class="hljs-name">form</span>&gt;</span>
</code></pre>
<h2>webapp/edit.jsp</h2>
<p>Шаблон с формой редактирования пользователя.</p>
<h2>Задачи</h2>
<ul>
<li data-marpit-fragment="12">Организуйте вывод вывод формы редактирования данных пользователя. Поля формы для имени, фамилии и email пользователя должны быть заполнены данными пользователя. Если были введены некорректные данные, на странице должно выводиться сообщение об ошибке, а поля должны быть заполнены введенными данным.</li>
</ul>
<h2>webapp/show.jsp</h2>
<h2>Задачи</h2>
<ul>
<li data-marpit-fragment="13">Добавьте на страницу пользователя ссылку на страницу редактирования пользователя.</li>
</ul>
<h2>Подсказки</h2>
<ul>
<li data-marpit-fragment="14">Для указания предварительно введенной строки для текстовых полей (input type=&quot;text&quot;) воспользуйтесь атрибутом <code>value</code>.</li>
<li data-marpit-fragment="15">Атрибут <code>name</code> тега <code>&lt;input&gt;</code> определяет имя элемента формы. Это имя используется при отправке данных на сервер. Чтобы получить эти данные в обработчике, воспользуйтесь методом <code>getParameter()</code>.</li>
<li data-marpit-fragment="16">Форма создания нового пользователя должна отображать введенные данные и сообщение об ошибке, если данные не прошли валидацию. Но при первом заполнении формы этих данных нет. Чтобы в шаблоне не возникла ошибка, в методе <code>newUser()</code> вам потребуется передать в шаблон &quot;пустого пользователя&quot; (пустой список <code>Map</code>) и пустое сообщение о ошибке, а в шаблоне воспользоваться методом <code>getOrDefault()</code> для получения данных пользователя.</li>
</ul>
</section>
<script>!function(){"use strict";const t="marpitSVGPolyfill:setZoomFactor,",e=Symbol();let r,o;function n(n){const i="object"==typeof n&&n.target||document,a="object"==typeof n?n.zoom:n;window[e]||(Object.defineProperty(window,e,{configurable:!0,value:!0}),window.addEventListener("message",(({data:e,origin:r})=>{if(r===window.origin)try{if(e&&"string"==typeof e&&e.startsWith(t)){const[,t]=e.split(","),r=Number.parseFloat(t);Number.isNaN(r)||(o=r)}}catch(t){console.error(t)}})));let l=!1;Array.from(i.querySelectorAll("svg[data-marpit-svg]"),(t=>{var e,n,i,s;t.style.transform||(t.style.transform="translateZ(0)");const c=a||o||t.currentScale||1;r!==c&&(r=c,l=c);const d=t.getBoundingClientRect(),{length:u}=t.children;for(let r=0;r<u;r+=1){const o=t.children[r],a=o.getScreenCTM();if(a){const t=null!==(n=null===(e=o.x)||void 0===e?void 0:e.baseVal.value)&&void 0!==n?n:0,r=null!==(s=null===(i=o.y)||void 0===i?void 0:i.baseVal.value)&&void 0!==s?s:0,l=o.firstElementChild,{style:u}=l;u.transformOrigin||(u.transformOrigin=`${-t}px ${-r}px`),u.transform=`scale(${c}) matrix(${a.a}, ${a.b}, ${a.c}, ${a.d}, ${a.e-d.left}, ${a.f-d.top}) translateZ(0.0001px)`}}})),!1!==l&&Array.from(i.querySelectorAll("iframe"),(({contentWindow:e})=>{null==e||e.postMessage(`${t}${l}`,"null"===window.origin?"*":window.origin)}))}r=1,o=void 0;const i=(t,e,r)=>{if(t.getAttribute(e)!==r)return t.setAttribute(e,r),!0};function a({once:t=!1,target:e=document}={}){const r="Apple Computer, Inc."===navigator.vendor?[n]:[];let o=!t;const a=()=>{for(const t of r)t({target:e});!function(t=document){Array.from(t.querySelectorAll('svg[data-marp-fitting="svg"]'),(t=>{var e;const r=t.firstChild,o=r.firstChild,{scrollWidth:n,scrollHeight:a}=o;let l,s=1;if(t.hasAttribute("data-marp-fitting-code")&&(l=null===(e=t.parentElement)||void 0===e?void 0:e.parentElement),t.hasAttribute("data-marp-fitting-math")&&(l=t.parentElement),l){const t=getComputedStyle(l),e=Math.ceil(l.clientWidth-parseFloat(t.paddingLeft||"0")-parseFloat(t.paddingRight||"0"));e&&(s=e)}const c=Math.max(n,s),d=Math.max(a,1),u=`0 0 ${c} ${d}`;i(r,"width",`${c}`),i(r,"height",`${d}`),i(t,"preserveAspectRatio",getComputedStyle(t).getPropertyValue("--preserve-aspect-ratio")||"xMinYMin meet"),i(t,"viewBox",u)&&t.classList.toggle("__reflow__")}))}(e),o&&window.requestAnimationFrame(a)};return a(),()=>{o=!1}}const l=Symbol(),s=document.currentScript;((t=document)=>{if("undefined"==typeof window)throw new Error("Marp Core's browser script is valid only in browser context.");if(t[l])return t[l];const e=a({target:t}),r=()=>{e(),delete t[l]};Object.defineProperty(t,l,{configurable:!0,value:r})})(s?s.getRootNode():document)}();
</script></foreignObject></svg></div>
      </body>
    </html>
  